Index: src/edu/ucsb/nceas/metacat/DBUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 1292)
@@ -470,5 +470,174 @@
 
     return accnum;
   }
-
+  
+  /**
+   * To a given docid, found a dataset docid which conatains the the given doicd
+   * This will be done by searching xml_relation table
+   * If couldn't find, null will be return
+   * @param givenDocId, the docid which we want to find
+   */
+  public static String findDataSetDocIdForGivenDocument(String givenDocId)
+  {
+    // Prepared statement for sql
+    PreparedStatement pStmt = null;
+    // Result set
+    ResultSet resultSet = null;
+    // String to store the data set docid
+    String dataSetDocId = null;
+    // DBConnection will be checkout
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    // String to store the sql command
+    String sqlCommand = null;
+    try
+    {
+      // Checkout DBConnection from pool
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBUtil.findDataSetDocIdForGivenDocument");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      // Sql command to chose a docid from xm_relation table
+      sqlCommand = "select docid from xml_relation where object like ? or " 
+                                                    + "subject like ?";
+      // Prepared statement
+      pStmt = dbConn.prepareStatement(sqlCommand);
+      // Bind variable
+      pStmt.setString(1, givenDocId);
+      pStmt.setString(2, givenDocId);
+      // Excute prepared statement
+      pStmt.execute();
+      // Get result set
+      resultSet = pStmt.getResultSet();
+      
+      // There has record
+      if (resultSet.next())
+      {
+        // Put the docid into dataSetDocid
+        dataSetDocId = resultSet.getString(1);
+        return dataSetDocId;
+      }//if
+      else
+      {
+        // No record in xml_relation table for given doicd, null returned
+        return dataSetDocId;
+      }//else
+    
+    }//try
+    catch ( SQLException e)
+    {
+      // Print out excepition
+      MetaCatUtil.debugMessage("Error in DBUil.findDataSEtDocIdForGivenDocument"
+                                +e.getMessage(), 30);
+      // return null
+      return dataSetDocId;
+     
+    }//catch
+    finally
+    {
+      try
+      {
+        // Close result set
+        resultSet.close();
+        // Close preparedStatement
+        pStmt.close();
+      }//try
+      catch ( SQLException e)
+      {
+        // Print out excepition
+        MetaCatUtil.debugMessage("Error in DBUil.findDataSetDocIdForGivenDoc"
+                                + e.getMessage(), 30);
+     
+      }//catch
+      finally
+      {
+        // Return DBConnection to the pool
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+        
+  }//findDataSetDocIdForGivenDocument
+  
+  /**
+   * Method to get current revision and doctype for a given docid
+   * The output will look like "rev;doctype"
+   * @param givenDocId, the docid which we want 
+   */
+  public String getCurrentRevisionAndDocTypeForGivenDocument(String givenDocId)
+                                                 throws SQLException
+  {
+    // DBConection for JDBC
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    // Prepared Statement
+    PreparedStatement pstmt = null;
+    // String to store a docid without rev
+    String docIdWithoutRevision = null;
+    // SQL comand
+    String sqlCommand = null;
+    // Resulst set
+    ResultSet rs = null;
+    // String to store the revision
+    String revision = null;
+    // String to store the doctype
+    String docType = null;
+    
+    // Get docid without rev
+    docIdWithoutRevision = MetaCatUtil.getDocIdFromString(givenDocId);
+    // SQL comand is:
+    sqlCommand = "select rev, doctype from xml_documents where docid like ?";
+    
+    try
+    {
+      // Check out the connection
+      dbConn=DBConnectionPool.
+         getDBConnection("DBUtil.getCurrentRevisionAndDocTypeForGivenDocument");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      
+      // Prepare the sql command
+      pstmt = dbConn.prepareStatement(sqlCommand);
+      // Bin vairable
+      pstmt.setString(1, docIdWithoutRevision);
+      // Excute the prepared statement
+      pstmt.execute();
+      // Get result set
+      rs = pstmt.getResultSet();
+      // If there is some record
+      if (rs.next())
+      {
+        revision = rs.getString(1);
+        docType = rs.getString(2);
+      }//if
+      else
+      {
+        // No record, throw a exception
+        throw new 
+              SQLException("There is not record for given docid:"+givenDocId);
+      }//else
+        
+    }
+    finally
+    {
+      try
+      {
+        // Close result set
+        rs.close();
+        // Close preparedStatement
+        pstmt.close();
+      }//try
+      catch ( SQLException e)
+      {
+        // Print out excepition
+        MetaCatUtil.debugMessage("Error in DBUil.getCurrentRevisionAndDocType"
+                                + e.getMessage(), 30);
+     
+      }//catch
+      finally
+      {
+        // Return DBConnection to the pool
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }
+    return revision+";"+docType;
+  }//getCurrentRevisionAndDocTypeForGivenDocument
+   
 }
Index: src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 1292)
@@ -48,27 +48,52 @@
 public class ForceReplicationHandler implements Runnable
 {
   private Thread btThread;
-  //private Connection conn;
   private MetaCatUtil util = new MetaCatUtil();
   private String docid;
   private String action;
   private boolean xmlDocument;
   private boolean dbactionFlag = true;
-  private Hashtable serverList;
+  private ReplicationServerList serverLists = null;//Serverlist 
+  private int homeServerCode = 0; // home server code for the docid
+  // When a metacat A got forcereplication 
+  // notification from B, then A will update its record. And A will notification
+  // other metacat in its serverlist to update this docid if A is a hub. But we
+  // don't want A to notify B again. B is nofitification of A
+  private String notificationServer = null;
   
   
+  
   /**
+   * Constructor of ForceReplicationHandler
    * @param docid the docid to force replicate
    * @param the action that is being performed on the document (either 
    *        INSERT or UPDATE)
+   * @param xml the docid is a xml document or not (data file)
+   * @param notificationServer, when a metacat A got forcereplication 
+   * notification from B, then A will update its record. And A will notification
+   * other metacat in its serverlist to update this docid if A is a hub. But we
+   * don't want A to notify B again. B is nofitification of A.
    */
   public ForceReplicationHandler(String docid, String action, boolean xml, 
-                                                          Hashtable server )
+                                                   String myNotificationServer)
   {
     this.docid = docid;
     this.action = action;
     this.xmlDocument =xml;
-    this.serverList = server;
+    // Build a severLists from xml_replication table
+    this.serverLists = new ReplicationServerList();
+    // Get sever code for this docid
+    try
+    {
+      this.homeServerCode = MetacatReplication.getHomeServerCodeForDocId(docid);
+    }//try
+    catch (Exception e)
+    {
+      MetaCatUtil.debugMessage("Error in ForceReplicationHandle(): "
+                                                          +e.getMessage(), 30);
+    }//catch
+    // Get the notification server
+    this.notificationServer = myNotificationServer;
     
     if(this.action.equals(""))
     {
@@ -83,101 +108,215 @@
   /**
    * Use this constructor when the action is implied.
    */
-  public ForceReplicationHandler(String docid, boolean xml, Hashtable server)
+  public ForceReplicationHandler(String docid, boolean xml, 
+                                                String myNotificationServer )
   {
     this.docid = docid;
     this.xmlDocument = xml;
     dbactionFlag = false;
-    this.serverList = server;
+    // Build a severLists from xml_replication table
+    this.serverLists = new ReplicationServerList();
+    // Get home server code for this doicd
+    try
+    {
+      this.homeServerCode = MetacatReplication.getHomeServerCodeForDocId(docid);
+    }
+     catch (Exception e)
+    {
+      MetaCatUtil.debugMessage("Error in ForceReplicationHandle(): "
+                                                          +e.getMessage(), 30);
+    }//catch
+    // Get notification server
+    this.notificationServer = myNotificationServer;
     btThread = new Thread(this);
     btThread.setPriority(Thread.MIN_PRIORITY);
     btThread.start();
   }
   
+  /**
+   * Method to send force replication command to other server to get 
+   * a new or updated docid
+   */
   public void run()
   {
-    //System.out.println("in ForceReplicationHandler Thread");
+    
     try
     {
-      //check if the metacat was configured to hanldle replication
-      if (!(util.getOption("replication")).equals("on"))
-      {
-         return;
-      }
+      // URL for notifcation
       URL comeAndGetIt = null;
-      //conn = util.getConnection();
       // If no server in xml_replication table, metacat don't need do anything
-      if (ReplicationHandler.buildServerList()==null)
+      if (serverLists.isEmpty())
       {
         return;
       }
-      //Enumeration keys = (ReplicationHandler.buildServerList(conn)).keys();
-      //Make sure that server list is not empty
-      if (serverList==null || serverList.isEmpty())
-      {
-        return;
-      }
       
-      Enumeration keys = serverList.keys();
-      //get the list of servers
-      while(keys.hasMoreElements())
+      // Thread seelping for some seconds to make sure the document was insert 
+      // into the database before we send force replication request
+      int sleepTime = Integer.parseInt
+                         (MetaCatUtil.getOption("forcereplicationwaitingtime"));
+      Thread.sleep(sleepTime);
+      MetaCatUtil.debugMessage("notification server:"+notificationServer, 34);
+      // Check every server in the serverlists
+      for (int i=0; i<serverLists.size(); i++)
       {
-        String server = (String)(keys.nextElement());
-        if(dbactionFlag)
+        //Set comeAndGetIt null
+        comeAndGetIt = null;
+        // Get ReplicationServer object in index i
+        ReplicationServer replicationServer = serverLists.serverAt(i);
+       // Get this ReplicationServer 's name
+        String server = replicationServer.getServerName();
+        
+        // If the server is the notification server, we don't notify it back 
+        // again, if server is null we don't replication it
+        if (server!=null && !server.equals(notificationServer))
         {
-            if (xmlDocument)// xml documents
+          
+          if(dbactionFlag)
+          {
+            // xml documents and server can replicate xml doucment
+            if (xmlDocument && replicationServer.getReplication())
             {
-              MetacatReplication.replLog("force xml replicating to " + server);
-              comeAndGetIt = new URL("https://" + server + 
+              // If this docid's homeserver is localhost, replicate it
+              if (homeServerCode==1)
+              {
+                MetacatReplication.replLog("force xml replicating to " 
+                                                                    + server);
+                comeAndGetIt = new URL("https://" + server + 
                                  "?action=forcereplicate&server=" + 
                                  util.getOption("server") + 
                                  util.getOption("replicationpath") +
                                  "&docid=" + docid + "&dbaction=" +
                                   action);
-            }
+              }//if servercode==1
+              else if (replicationServer.getHub()||
+                   server.equals(MetacatReplication.
+                                  getServerNameForServerCode(homeServerCode)))
+              {
+                // If the docid's home server is not local host, but local host
+                // is a hub of this server, replicate the docid too.
+                // If the server is homeserver of the docid, replication it too
+                MetacatReplication.replLog("force xml replicating to " 
+                                                                    + server);
+                comeAndGetIt = new URL("https://" + server + 
+                                 "?action=forcereplicate&server=" + 
+                                 util.getOption("server") + 
+                                 util.getOption("replicationpath") +
+                                 "&docid=" + docid + "&dbaction=" +
+                                  action);
+               
+              }//else
+             
+            }//if xmlDocument
             //It is data file and configured to handle data replication
-            else if ((util.getOption("replicationsenddata")).equals("on"))
+            else if (replicationServer.getDataReplication())
             {
-              MetacatReplication.replLog("force data replicating to " + server);
-              comeAndGetIt = new URL("https://" + server + 
+              // If the docid's home server is local host, replicate the docid
+              if (homeServerCode==1)
+              {
+                MetacatReplication.replLog("force data replicating to " 
+                                                                      + server);
+                comeAndGetIt = new URL("https://" + server + 
                                  "?action=forcereplicatedatafile&server=" + 
                                  util.getOption("server") + 
                                  util.getOption("replicationpath") +
                                  "&docid=" + docid + "&dbaction=" +
                                   action);
-                                
-            }//else if
+              }//if serverCode==1
+              else if (replicationServer.getHub()||
+                server.equals(MetacatReplication.
+                                    getServerNameForServerCode(homeServerCode)))
+              {
+                // If the docid's home server is not local host, but local host 
+                // is a hub of this server, replicate the docid too.
+                // If the server is homeserver of the docid replication it too
+                 MetacatReplication.replLog("force data replicating to " 
+                                                                      + server);
+                comeAndGetIt = new URL("https://" + server + 
+                                 "?action=forcereplicatedatafile&server=" + 
+                                 util.getOption("server") + 
+                                 util.getOption("replicationpath") +
+                                 "&docid=" + docid + "&dbaction=" +
+                                  action);
+                
+              }//else if servercode==1
+            }//else if data file
     
-        }//if
-        else
-        {
-          MetacatReplication.replLog("force replicating (default action) to )" + 
-                                      server);
-          if (xmlDocument)
-          {
-            comeAndGetIt = new URL("https://" + server + 
+          }//if has explicite action
+          else
+          { // has implicite action
+            MetacatReplication.replLog("force replicating (default action) to )"
+                                                + server);
+            // this docid is xml documents and can replicate xml doucment
+            if (xmlDocument && replicationServer.getReplication())
+            {
+              // If homeserver of this doicd is local, replicate it
+              if (homeServerCode ==1)
+              { 
+                comeAndGetIt = new URL("https://" + server + 
                                  "?action=forcereplicate&server=" + 
                                  util.getOption("server") + 
                                  util.getOption("replicationpath") +
                                  "&docid=" + docid);
-          }
-          //It is datafile and metacat is configured to handle data file
-          else if ((util.getOption("replicationsenddata")).equals("on"))
-          {
-            comeAndGetIt = new URL("https://" + server + 
+                
+              }//if homeserver ==1
+              else if (replicationServer.getHub()||
+                   server.equals(MetacatReplication.
+                   getServerNameForServerCode(homeServerCode)))
+              {
+                // If home server of this docid is not local host, but local 
+                // host is a hub for this server, replicate this doicd
+                // If the server is homeserver of the docid, replication it too
+                comeAndGetIt = new URL("https://" + server + 
+                                 "?action=forcereplicate&server=" + 
+                                 util.getOption("server") + 
+                                 util.getOption("replicationpath") +
+                                 "&docid=" + docid);
+                
+              }//else if
+              
+            }//if xmlDoucment
+            else if (replicationServer.getDataReplication())          
+            { //It is datafile and server is configured to replicate data file
+              
+              //if home server is local host, replicate the data file
+              if (homeServerCode ==1)
+              {
+                comeAndGetIt = new URL("https://" + server + 
                                  "?action=forcereplicatedatafile&server=" + 
                                  util.getOption("server") + 
                                  util.getOption("replicationpath") +
                                  "&docid=" + docid);
-          }//else if
-        }//else
-        MetaCatUtil.debugMessage("sending message: " + comeAndGetIt.toString());
-        String message = MetacatReplication.getURLContent(comeAndGetIt);
-        //send out the url.  message is a dummy variable as the target of
-        //the URL never directly replies to the request.  this simply
-        //invoces a read request from the server to this local machine.
-      }//while
-      //util.returnConnection(conn);
+              }//if
+              else if (replicationServer.getHub()||
+                          server.equals(MetacatReplication.
+                          getServerNameForServerCode(homeServerCode)))
+              {
+                // If home server is not local host, but the local host is a hub
+                // For this server, replicate the data file
+                // If the server is homeserver of the docid, replication it too
+                comeAndGetIt = new URL("https://" + server + 
+                                 "?action=forcereplicatedatafile&server=" + 
+                                 util.getOption("server") + 
+                                 util.getOption("replicationpath") +
+                                 "&docid=" + docid);
+                
+              }//else
+            }//else if
+          }//else has implicit action
+          
+          //Make sure comeAndGetIt is not empty
+          if ( comeAndGetIt != null && !comeAndGetIt.equals(""))
+          {
+            MetaCatUtil.debugMessage("sending message: " 
+                                                + comeAndGetIt.toString(), 25);
+            String message = MetacatReplication.getURLContent(comeAndGetIt);
+          }
+          //send out the url.  message is a dummy variable as the target of
+          //the URL never directly replies to the request.  this simply
+          //invoces a read request from the server to this local machine.
+        }//if notification server
+      }//for
+     
     }//try
     catch(Exception e)
     {
@@ -185,6 +324,6 @@
                           e.getMessage());
       e.printStackTrace(System.out);
     }
-    MetaCatUtil.debugMessage("exiting ForceReplicationHandler Thread");
-  }
-}
+    MetaCatUtil.debugMessage("exiting ForceReplicationHandler Thread", 25);
+  }//run
+}//ForceReplication class
Index: src/edu/ucsb/nceas/metacat/McdbDocNotFoundException.java
===================================================================
--- src/edu/ucsb/nceas/metacat/McdbDocNotFoundException.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/McdbDocNotFoundException.java	(revision 1292)
@@ -35,11 +35,16 @@
  */
 public class McdbDocNotFoundException extends McdbException {
 
+  // String sto stroe which docid couldn't find
+  private String unfoundDocId = null;
+  private String unfoundRevision = null;
   /**
    * Create a new McdbDocNotFoundException.
    */
   public McdbDocNotFoundException() {
     super();
+    unfoundDocId = null;
+    unfoundRevision = null;
   }
 
   /**
@@ -47,8 +52,11 @@
    *
    * @param message The error or warning message.
    */
-  public McdbDocNotFoundException(String message) {
+  public McdbDocNotFoundException(String message, String givenDocId, 
+                                                    String givenRevision) {
     super(message);
+    unfoundDocId = givenDocId;
+    unfoundRevision = givenRevision;
   }
 
   /**
@@ -69,4 +77,20 @@
   public McdbDocNotFoundException(String message, Exception e) {
     super(message, e);
   }
+  
+  /**
+   * Method to get the docid which couldn't be found
+   */
+  public String getUnfoundDocId ()
+  {
+    return unfoundDocId;
+  }// getUnfoundDocid
+  
+  /**
+   * Method to get the docid's revsion which couldn't be found
+   */
+  public String getUnfoundRevision ()
+  {
+    return unfoundRevision;
+  }// getUnfoundDocid
 }
